"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Event_1 = __importDefault(require("../../event/Event"));
var ErrorEvent_1 = __importDefault(require("../../event/events/ErrorEvent"));
var ResourceFetcher_1 = __importDefault(require("../../fetch/ResourceFetcher"));
/**
 * Helper class for getting the URL relative to a Location object.
 */
var ScriptUtility = /** @class */ (function () {
    function ScriptUtility() {
    }
    /**
     * Returns a URL relative to the given Location object.
     *
     * @param options Options.
     * @param options.element Element.
     * @param element
     */
    ScriptUtility.loadExternalScript = function (element) {
        return __awaiter(this, void 0, void 0, function () {
            var src, async, code, error_1, code;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        src = element.getAttributeNS(null, 'src');
                        async = element.getAttributeNS(null, 'async') !== null;
                        if (!async) return [3 /*break*/, 5];
                        code = null;
                        element.ownerDocument._readyStateManager.startTask();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, ResourceFetcher_1.default.fetch({
                                window: element.ownerDocument.defaultView,
                                url: src
                            })];
                    case 2:
                        code = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        element.dispatchEvent(new ErrorEvent_1.default('error', {
                            message: error_1.message,
                            error: error_1
                        }));
                        element.ownerDocument.defaultView.dispatchEvent(new ErrorEvent_1.default('error', {
                            message: error_1.message,
                            error: error_1
                        }));
                        if (!element._listeners['error'] &&
                            !element.ownerDocument.defaultView._listeners['error']) {
                            element.ownerDocument.defaultView.console.error(error_1);
                        }
                        return [3 /*break*/, 4];
                    case 4:
                        if (code) {
                            element.ownerDocument.defaultView.eval(code);
                            element.dispatchEvent(new Event_1.default('load'));
                        }
                        element.ownerDocument._readyStateManager.endTask();
                        return [3 /*break*/, 6];
                    case 5:
                        code = null;
                        try {
                            code = ResourceFetcher_1.default.fetchSync({
                                window: element.ownerDocument.defaultView,
                                url: src
                            });
                        }
                        catch (error) {
                            element.dispatchEvent(new ErrorEvent_1.default('error', {
                                message: error.message,
                                error: error
                            }));
                            element.ownerDocument.defaultView.dispatchEvent(new ErrorEvent_1.default('error', {
                                message: error.message,
                                error: error
                            }));
                            if (!element._listeners['error'] &&
                                !element.ownerDocument.defaultView._listeners['error']) {
                                element.ownerDocument.defaultView.console.error(error);
                            }
                        }
                        if (code) {
                            element.ownerDocument.defaultView.eval(code);
                            element.dispatchEvent(new Event_1.default('load'));
                        }
                        _a.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    return ScriptUtility;
}());
exports.default = ScriptUtility;
//# sourceMappingURL=ScriptUtility.js.map