"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Selection.
 *
 * Reference:
 * https://developer.mozilla.org/en-US/docs/Web/API/Selection.
 */
var Selection = /** @class */ (function () {
    function Selection() {
        this.anchorNode = null;
        this.anchorOffset = 0;
        this.baseNode = null;
        this.baseOffset = 0;
        this.extentNode = null;
        this.extentOffset = 0;
        this.focusNode = null;
        this.focusOffset = 0;
        this.isCollapsed = true;
        this.rangeCount = 0;
        this.type = 'None';
    }
    /**
     * Adds a range.
     *
     * @param _range Range.
     */
    Selection.prototype.addRange = function (_range) {
        // Do nothing.
    };
    /**
     * Collapses the current selection to a single point.
     *
     * @param _node Node.
     * @param _offset Offset.
     */
    Selection.prototype.collapse = function (_node, _offset) {
        // Do nothing.
    };
    /**
     * Collapses the selection to the end.
     */
    Selection.prototype.collapseToEnd = function () {
        // Do nothing.
    };
    /**
     * Collapses the selection to the start.
     */
    Selection.prototype.collapseToStart = function () {
        // Do nothing.
    };
    /**
     * Indicates whether a specified node is part of the selection.
     *
     * @param _node Node.
     * @param _partialContainer Partial container.
     * @returns Always returns "true" for now.
     */
    Selection.prototype.containsNode = function (_node, _partialContainer) {
        return true;
    };
    /**
     * Deletes the selected text from the document's DOM.
     */
    Selection.prototype.deleteFromDocument = function () {
        // Do nothing.
    };
    /**
     * Moves the focus of the selection to a specified point.
     *
     * @param _node Node.
     * @param _offset Offset.
     */
    Selection.prototype.extend = function (_node, _offset) {
        // Do nothing.
    };
    /**
     * Moves the focus of the selection to a specified point.
     *
     * @param _index Index.
     */
    Selection.prototype.getRangeAt = function (_index) {
        throw new Error('Not a valid index.');
    };
    /**
     * Removes a range from a selection.
     *
     * @param _range Range.
     */
    Selection.prototype.removeRange = function (_range) {
        // Do nothing.
    };
    /**
     * Removes all ranges.
     */
    Selection.prototype.removeAllRanges = function () {
        // Do nothing.
    };
    /**
     * Selects all children.
     *
     * @param _parentNode Parent node.
     */
    Selection.prototype.selectAllChildren = function (_parentNode) {
        // Do nothing.
    };
    /**
     * Sets the selection to be a range including all or parts of two specified DOM nodes, and any content located between them.
     *
     * @param _anchorNode Anchor node.
     * @param _anchorOffset Anchor offset.
     * @param _focusNode Focus node.
     * @param _focusOffset Focus offset.
     */
    Selection.prototype.setBaseAndExtent = function (_anchorNode, _anchorOffset, _focusNode, _focusOffset) {
        // Do nothing.
    };
    /**
     * Returns string currently being represented by the selection object.
     */
    Selection.prototype.toString = function () {
        return '';
    };
    return Selection;
}());
exports.default = Selection;
//# sourceMappingURL=Selection.js.map